Index: colors.py
===================================================================
--- colors.py	(revision 8944)
+++ colors.py	(working copy)
@@ -514,15 +514,17 @@
             xma = ma.array(X, copy=True)
             xa = xma.filled(0)
             mask_bad = ma.getmask(xma)
+            del xma
         if xa.dtype.char in np.typecodes['Float']:
             np.putmask(xa, xa==1.0, 0.9999999) #Treat 1.0 as slightly less than 1.
             # The following clip is fast, and prevents possible
             # conversion of large positive values to negative integers.
 
+            xa *= self.N
             if NP_CLIP_OUT:
-                np.clip(xa * self.N, -1, self.N, out=xa)
+                np.clip(xa, -1, self.N, out=xa)
             else:
-                xa = np.clip(xa * self.N, -1, self.N)
+                xa = np.clip(xa, -1, self.N)
 
             # ensure that all 'under' values will still have negative
             # value after casting to int
@@ -803,25 +805,33 @@
 
         if cbook.iterable(value):
             vtype = 'array'
-            val = ma.asarray(value).astype(np.float)
+            result = ma.asarray(value)
+            if result.dtype.kind == 'f':
+                if isinstance(value, np.ndarray):
+                    result = result.copy()
+            elif result.dtype.itemsize > 2:
+                result = result.astype(np.float)
+            else:
+                result = result.astype(np.float32)
         else:
             vtype = 'scalar'
-            val = ma.array([value]).astype(np.float)
+            result = ma.array([value]).astype(np.float)
 
-        self.autoscale_None(val)
+        self.autoscale_None(result)
         vmin, vmax = self.vmin, self.vmax
         if vmin > vmax:
             raise ValueError("minvalue must be less than or equal to maxvalue")
-        elif vmin==vmax:
-            result = 0.0 * val
+        elif vmin == vmax:
+            result[:] = 0.0
         else:
             vmin = float(vmin)
             vmax = float(vmax)
             if clip:
-                mask = ma.getmask(val)
-                val = ma.array(np.clip(val.filled(vmax), vmin, vmax),
-                                mask=mask)
-            result = (val-vmin) / (vmax-vmin)
+                mask = ma.getmask(result)
+                result = ma.array(np.clip(result.filled(vmax), vmin, vmax),
+                                  mask=mask)
+            result -= vmin
+            result /= vmax - vmin
         if vtype == 'scalar':
             result = result[0]
         return result
